//      destructor.c
//      
//      Copyright 2011 grchere <grchere@debian2>
//      
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <string.h>
#include <sys/ipc.h> 
#include <sys/shm.h> 
#include <sys/sem.h> 

int main(int argc, char **argv)
{
	int shm1,shm2,conta1,conta2,sem1,sem2;
	
	// obtengo id de memoria compartida ( obtener_memoria() )
	shm1 = shmget(0xA,0,0);
	shm2 = shmget(0xB,0,0);
	conta1 = shmget(0xA1,0,0);
	conta2 = shmget(0xB1,0,0);
	
	// obtengo id de semaforos ( obtener_semaforo() )
	sem1 = semget(0xA,0,0);
	sem2 = semget(0xB,0,0);

	printf("shm1 = %d\n",shm1);
	printf("shm2 = %d\n",shm2); 
	printf("conta1 = %d\n",conta1);  
	printf("conta2 = %d\n",conta2); 
	printf("sem1 = %d\n",sem1); 
	printf("sem2 = %d\n",sem2); 
	
	// borro memoria compartida ( borrar_memoria() )
	shmctl(shm1, IPC_RMID, 0);
	shmctl(shm2, IPC_RMID, 0);
	shmctl(conta1, IPC_RMID, 0);
	shmctl(conta2, IPC_RMID, 0);

	// borro semaforos ( borrar_semaforo() )
	semctl(sem1, 1, IPC_RMID, 0);
	semctl(sem2, 1, IPC_RMID, 0);
	
	return 0;
}


