//      escritor1b.c
//      
//      Copyright 2011 grchere <grchere@debian2>
//      
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.


#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <string.h>
#include <sys/ipc.h> 
#include <sys/shm.h> 
#include <sys/sem.h> 

#include "mipv.h"

int main(int argc, char **argv)
{
	// mensaje a almacenar en memoria compartida
	struct mensaje {
		char msg[512];
	} mensaje;

	// variable para apuntar al i-esimo mensaje en memoria compartida
	int pone = 0;

	// obtener los ids de los recursos ipcs
	int shm1,conta1;
	int sem1;
	shm1 = shmget(0xA,0,0);
	conta1 = shmget(0xA1,0,0);
	sem1 = semget(0xA,0,0);
	
	printf("shm1 = %d\n",shm1);
	printf("conta1 = %d\n",conta1);
	printf("sem1 = %d\n",sem1);
	
	// obtener las direcciones de mapeo de las areas de mem. compartida
	struct mensaje *dirshm1 = (struct mensaje *) shmat(shm1,0,0);
	int *dirconta1 = (int *) shmat(conta1,0,0);
	
	// condicion de finalizacion del escritor
	printf("Msg:\n");
	memset(&mensaje,0,sizeof(struct mensaje)); // limpio buffer mensaje
	fgets(mensaje.msg,512,stdin);
	while(strncmp(mensaje.msg,"chau",4)) {
		// bloqueo del escritor cuando shm esta llena (busy waiting)
		while(*dirconta1 == 10);
		// si puede escribir entonces..
		
			// seccion entrante ( semWait() )
			P(sem1,0);
			
			// seccion critica
			memcpy(dirshm1+pone,&mensaje,sizeof(struct mensaje));
			pone=(pone+1) % 10;
			(*dirconta1)++;
			printf("conta1 = %d\n",*dirconta1);
			
			// seccion saliente  ( semSignal() )
			V(sem1,0);
			
		// salida del escritor
		printf("Msg:\n");
		memset(&mensaje,0,sizeof(struct mensaje)); // limpio buffer mensaje
		fgets(mensaje.msg,512,stdin);
	}
	// ojo! falta escribir chau en shm
	while(*dirconta1 == 10);
	// si puede escribir entonces..
	
		// seccion entrante
		P(sem1,0);
			
		// seccion critica
		memcpy(dirshm1+pone,&mensaje,sizeof(struct mensaje));
		pone=(pone+1) % 10;
		(*dirconta1)++;
		printf("conta1 = %d\n",*dirconta1);
			
		// seccion saliente
		V(sem1,0);
	
	// dettach - desconecto memoria compartida ( desconectar_memoria() )
	shmdt(dirshm1);
	shmdt(dirconta1);

	return 0;
}

