//      escritor2.c
//      
//      Copyright 2011 grchere <grchere@debian2>
//      
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.


#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <string.h>
#include <sys/ipc.h> 
#include <sys/shm.h> 
#include <sys/sem.h> 

#include "mipv.h"

int main(int argc, char **argv)
{
	// mensaje a almacenar en memoria compartida
	struct mensaje {
		char msg[512];
	} mensaje;

	// variable para apuntar al i-esimo mensaje en memoria compartida
	int pone = 0;

	// obtener los ids de los recursos ipcs
	int shm2,conta2;
	int sem2;
	shm2 = shmget(0xB,0,0);
	conta2 = shmget(0xB1,0,0);
	sem2 = semget(0xB,0,0);
	
	printf("shm2 = %d\n",shm2);
	printf("conta2 = %d\n",conta2);
	printf("sem2 = %d\n",sem2);
	
	// obtener las direcciones de mapeo de las areas de mem. compartida
	struct mensaje *dirshm2 = (struct mensaje *) shmat(shm2,0,0);
	int *dirconta2 = (int *) shmat(conta2,0,0);
	
	// condicion de finalizacion del escritor
	printf("Msg:\n");
	memset(&mensaje,0,sizeof(struct mensaje)); // limpio buffer mensaje
	fgets(mensaje.msg,512,stdin);
	while(strncmp(mensaje.msg,"chau",4)) {
		// bloqueo del escritor cuando shm esta llena (busy waiting)
		while(*dirconta2 == 10);
		// si puede escribir entonces..
		
			// seccion entrante ( semWait() )
			P(sem2,0);
			
			// seccion critica
			memcpy(dirshm2+pone,&mensaje,sizeof(struct mensaje));
			pone=(pone+1) % 10;
			(*dirconta2)++;
			printf("conta2 = %d\n",*dirconta2);
			
			// seccion saliente ( semSignal() )
			V(sem2,0);
			
		// salida del escritor
		printf("Msg:\n");
		memset(&mensaje,0,sizeof(struct mensaje)); // limpio buffer mensaje
		fgets(mensaje.msg,512,stdin);
	}
	// ojo! falta escribir chau en shm
	while(*dirconta2 == 10);
	// si puede escribir entonces..
	
		// seccion entrante
		P(sem2,0);
			
		// seccion critica
		memcpy(dirshm2+pone,&mensaje,sizeof(struct mensaje));
		pone=(pone+1) % 10;
		(*dirconta2)++;
		printf("conta2 = %d\n",*dirconta2);
			
		// seccion saliente
		V(sem2,0);
	
	// dettach - desconecto memoria compartida ( desconectar_memoria() )
	shmdt(dirshm2);
	shmdt(dirconta2);

	return 0;
}

