//      inicializador.c
//      
//      Copyright 2011 grchere <grchere@debian2>
//      
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.


#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <string.h>
#include <sys/ipc.h> 
#include <sys/shm.h> 
#include <sys/sem.h> 

int main(int argc, char **argv)
{
	int shm1,shm2,conta1,conta2;
	int sem1,sem2;
	
	// obtengo id de memoria compartida ( obtener_memoria() )
	shm1 = shmget(0xA,0,0);
	shm2 = shmget(0xB,0,0);
	conta1 = shmget(0xA1,0,0);
	conta2 = shmget(0xB1,0,0);
	
	// obtengo id de semaforos ( obtener_semaforo() )
	sem1 = semget(0xA,0,0);
	sem2 = semget(0xB,0,0);

	printf("shm1 = %d\n",shm1);
	printf("shm2 = %d\n",shm2); 
	printf("conta1 = %d\n",conta1);  
	printf("conta2 = %d\n",conta2); 
	printf("sem1 = %d\n",sem1); 
	printf("sem2 = %d\n",sem2); 
	
	// attach - conecto memoria compartida ( conectar_memoria() )
	char *dirshm1 = (char *) shmat(shm1,0,0);
	char *dirshm2 = (char *) shmat(shm2,0,0);
	int *dirconta1 = (int *) shmat(conta1,0,0);
	int *dirconta2 = (int *) shmat(conta2,0,0);
	
	// inicializo (lleno con nuls) todas las areas de memoria compartida
	memset(dirshm1,0,5120);
	memset(dirshm2,0,5120);
	memset(dirconta1,0,sizeof(int));
	memset(dirconta2,0,sizeof(int));
	
	// dettach - desconecto memoria compartida ( desconectar_memoria() )
	shmdt(dirshm1);
	shmdt(dirshm2);
	shmdt(dirconta1);
	shmdt(dirconta2);
	
	// inicializo sem1 y sem2 a 1
	semctl(sem1,0,SETVAL,1);
	semctl(sem2,0,SETVAL,1);
	
	return 0;
}

